unit winomeg;
//deklaracje funkcji z biblioteki elzabdr.dll dla Delphi
interface
type
tBufferOfBytes = array [1..256] of byte;
Device = (FP6A5ST, FP6A7ST, OMEGA1, OMEGA2, FP6B5ST, FP6B7ST, OMEGAF, MERA, MERA_F, NAJNOWSZE);
const
  LIBR  =  'elzabdr.dll';
  E_OK        =  0;
  E_SEND_TIMEOUT = 20;
  E_RECV_TIMEOUT = 21;
  E_IMPROPER_ANS = 23;
  E_NEGATIVE_ACK = 24;
  E_INIT_FAIL    = 99;
  //b) bledy zwiazane z brakiem mozliwosci wystawienia paragonu
  E_PRODUCENT   = 100;
  E_ZWORA       = 101;
  E_KONTROLER   = 102;
  E_AWARIA_DR   = 103;
  E_UZYTKOWNIK  = 104;
  E_TYLKO_ODCZYT = 105;
  E_WYSWIETLACZ = 106;
  E_CMOS        =  107;
  E_ZALEGLY_R   = 108;
  E_BRAK_PAPIERU = 109;
  E_DOK_DO_DRUK = 110;
  E_ZN_DO_DRUK = 111;
  E_WYDR_ZATRZ = 112;
  E_STAWKI  = 113;
  E_PORT = 114;
  E_INSIDE_R = 200;
  E_OUTSIDE_R = 201;
  E_ZNAKI_ZNACZACE = 202;
  E_STAWKA = 203;
  E_KOMUNIKAT = 204;
  E_ILOSC = 205;
  E_MP = 206;
  E_JEDN = 207;
  E_CENA = 208;
  E_WARTOSC = 209;
  E_UNIEWAZN = 210;
  E_ZERO_PARAG = 211;
  E_DPOZA_ZAKR = 212;
  E_ROZKAZ_NIED = 213;
  E_PPOZA_ZAKR = 214;
  E_ZAKRES     = 215;
  E_LINES       = 216;
  E_NIESTAWKI = 217;
  E_NIEZEROP = 218;
  //bledy zwiazane z raportami okresowymi
  E_DATA     =  219;
  E_BRAK_RAP =  220;
  E_NUMERY   =  221;
  E_MIESIAC  =  222;
  E_PARAM    =  223;
  E_WERSJA   =  224;
  E_RET_PAR_NULL = 225;
  E_REZERWA      = 226;
  E_IL_CENA     =       227;
 //bdy zwizane z przestawianiem zegara
  E_0PRZESTAW   = 228;
  E_60PRZESTAW  = 229;
  E_NOPRZESTAW  = 230;
  E_EXCEPTION    =       999;

function OpenPort(Port:longword; BaudRate:word; WriteTimeout,ReadTimeout:word):longword;StdCall;
function ClosePort : longword; StdCall;
function IsCodePage1250(var Is1250 : longword) : longword;StdCall;
function DeviceType(var Dev : Device; var  Prog : longword) : longword;StdCall;
function PrintControl(BeforePrinting : longword) : longword;StdCall;
function ReadVAT (var Ile : longword; var A,B,C,D,E,F,G : longword): longword; StdCall;
function ErasePayments : longword;StdCall;
function EraseLines : longword;StdCall;
function pFillPayment(PaymentNo : longword; PaymentName : PChar; Total, Rest : longword) : longword;StdCall;
function pSendPayment(PaymentNo : longword; PaymentName : PChar; Total, Rest : longword) : longword;StdCall;
function pCurrencyPayment1(CurrencyName : PChar; Rate : PChar; Quantity : longword; Subtotal : longword; Send : longword) : longword;StdCall;
function pCurrencyPayment2(TotalInCurrency : longword; TotalInBaseCurrency: longword; Change : longword; TypeOfChange : longword; Send : longword) : longword;StdCall;
function pFillLines(Nr : longword; Line : PChar;var FreeLines : longword) : longword;StdCall;
function pDllVersion(Ver : PChar) : longword;StdCall;
function pDllAuthor(Auth : PChar) : longword;StdCall;
function PackageItem(Param : longword;Nr : word ; Ilosc : word; Cena : longword): longword;StdCall;
function DiscountOrSurcharge(Discount : longword; Kwota : longword) : longword;Stdcall;
function PrintSubtotal : longword;StdCall;
function OpenDrawer(DrawerNumber : longword) : longword;StdCall;
function DailyReport(Unconditionally : longword) : longword;StdCall;
function LockedArticlesReport : longword;StdCall;
function pErrMessage(ErrNo : longword; EMessage : PChar) : longword;StdCall;
function PrintResume : longword;StdCall;
function ReceiptConditions : longword;StdCall;
function CommunicationInit(NrPortu : longword; Szybkosc : longword; Timeout : longword) : longword;StdCall;
function CommunicationEnd : longword;StdCall;
function pDeviceName(Name : PChar) :longword;StdCall;
function pCharsInArticleName(N : PChar) : longword; StdCall;
function pReceiptItem(Sprzedaz : longword;Nazwa : PChar;Stawka, Komunikat : longword;Ilosc : longword; MP : longword;
                     Jedn : PChar; Cena : longword; var Wartosc : longword): longword;StdCall;
function pReceiptItemEx(Sprzedaz : longword;Nazwa : PChar;Stawka, Komunikat : longword;Ilosc : longword; MP : longword;
                     Jedn : PChar; Cena : longword): longword;StdCall;
function ReceiptEndEx(RabatNarzut : longword; TypRabatuNarzutu : longword) : longword;StdCall;
function ReceiptEnd(Rabat : longword) : longword;StdCall;
function ReceiptBegin : longword;StdCall;
function ReceiptNumber(var Numer : longword) : longword;StdCall;
function DailyReportNumber(var Numer : longword) : longword;StdCall;
function ReceiptCancel : longword;StdCall;
function ReadStatus(var S0 : longword; var S1 : longword; var S2 : longword; var S3 : longword) : longword; StdCall;
function PeriodReport(Fiscal : longword; yy1, mm1, dd1, yy2, mm2, dd2 : longword) : longword;StdCall;
function MonthlyReport(Fiscal : longword; Year,Month : longword) : longword;StdCall;
function NumberReport(Fiscal : longword; Nr1,Nr2 : longword) : longword;StdCall;
function pReadClock(Time : PChar) : longword;StdCall;
function WriteLineFeed(Ile : longword) : longword;StdCall;
function PrinterStatusReport : longword; StdCall;
function pReadUniqueNumber(Numer : PChar) : longword;StdCall;
function pControlPrintout(Operacja : longword; Nazwa : PChar; Stawka : longword) : longword;StdCall;
function ChangeTime(Hour : longword; Minute : longword) : longword;StdCall;
function pDisplayFP600(AddText : longword; Display : PChar): longword;StdCall;
function SetVAT (var Ile : longword; A,B,C,D,E,F,G : longword ): longword; StdCall;
function pReadTotal(sTotal : PChar) : longword;StdCall;
function pReadSelTotal(Rate : PChar; sTotal : PChar) : longword;StdCall;
function sCharsInArticleName(N : ShortString) : longword; StdCall;
function sDeviceName(var Name : ShortString) :longword;StdCall;
function sDllVersion(var Ver : ShortString) : longword;StdCall;
function sDllAuthor(var Auth : ShortString) : longword;StdCall;
function sErrMessage(ErrNo : longword; var EMessage : ShortString) : longword;StdCall;
function sFillPayment(PaymentNo : longword; PaymentName : ShortString; Total, Rest : longword) : longword;StdCall;
function sFillLines(Nr : longword; Line : ShortString;var FreeLines : longword) : longword;StdCall;
function sReceiptItem(Sprzedaz : longword;Nazwa : ShortString;Stawka, Komunikat : longword;Ilosc : longword; MP : longword;
                     Jedn : ShortString; Cena : longword; var Wartosc : longword): longword;StdCall;
function sReadClock(var Time : ShortString) : longword;StdCall;
function sReadUniqueNumber(var Numer : ShortString) : longword;StdCall;
function sReadTotal(var Total : ShortString) : longword;StdCall;
function sReadSelTotal(Rate : ShortString; var sTotal : ShortString) : longword;StdCall;
function RSSequence(ControlCode:longword;
                QuantityOfBytesToReceive:longword;
                QuantityOfBytesToSend:longword;
                var InputBuffer:tBufferOfBytes;
                OutputBuffer:tBufferOfBytes):longword; StdCall;
function sDisplayFP600(AddText : longword; Display : ShortString): longword;StdCall;
function SetDebugMode : longword;StdCall;
function ClearDebugMode : longword;StdCall;
function pWriteLogo(FileName : PCHar) : longword;StdCall;
function pWriteFooterLines(L1, L2, L3 : PCHar) : longword;StdCall;
function pReadFooterLines(L1, L2, L3 : PCHar) : longword;StdCall;
function NonFiscalPrintoutBegin(Number : longword) : longword;StdCall;
function pNonFiscalPrintoutLine(Number : longword; Text : PChar; If0A : longword): longword;StdCall;
function NonFiscalPrintoutEnd() : longword;StdCall;
function OptimizeTransmission : longword;StdCall;
function CancellationReason(var Reason : longword; Message : PChar) : longword;StdCall;

implementation

function OpenPort;external LIBR;
function ClosePort;external LIBR;
function IsCodePage1250;external LIBR;
function DeviceType;external LIBR;
function PrintControl;external LIBR;
function ReadVAT;external LIBR;
function ErasePayments;external LIBR;
function EraseLines;external LIBR;
function pFillPayment;external LIBR;
function pSendPayment;external LIBR;
function pCurrencyPayment1;external LIBR;
function pCurrencyPayment2;external LIBR;
function pFillLines;external LIBR;
function pDllVersion;external LIBR;
function pDllAuthor;external LIBR;
function PackageItem;external LIBR;
function DiscountOrSurcharge;external LIBR;
function PrintSubtotal;external LIBR;
function OpenDrawer;external LIBR;
function DailyReport;external LIBR;
function LockedArticlesReport;external LIBR;
function pErrMessage;external LIBR;
function PrintResume;external LIBR;
function ReceiptConditions;external LIBR;
function CommunicationInit;external LIBR;
function CommunicationEnd;external LIBR;
function pDeviceName;external LIBR;
function pCharsInArticleName;external LIBR;
function pReceiptItem;external LIBR;
function pReceiptItemEx;external LIBR;
function ReceiptEndEx;external LIBR;
function ReceiptEnd;external LIBR;
function ReceiptBegin;external LIBR;
function ReceiptNumber;external LIBR;
function DailyReportNumber;external LIBR;
function ReceiptCancel;external LIBR;
function ReadStatus;external LIBR;
function PeriodReport;external LIBR;
function MonthlyReport;external LIBR;
function NumberReport;external LIBR;
function pReadClock;external LIBR;
function WriteLineFeed;external LIBR;
function PrinterStatusReport;external LIBR;
function pReadUniqueNumber;external LIBR;
function pControlPrintout;external LIBR;
function ChangeTime;external LIBR;
function pDisplayFP600;external LIBR;
function SetVAT;external LIBR;
function pReadTotal;external LIBR;
function pReadSelTotal;external LIBR;
function sCharsInArticleName;external LIBR;
function sDeviceName;external LIBR;
function sDllVersion;external LIBR;
function sDllAuthor;external LIBR;
function sErrMessage;external LIBR;
function sFillPayment;external LIBR;
function sFillLines;external LIBR;
function sReceiptItem;external LIBR;
function sReadClock;external LIBR;
function sReadUniqueNumber;external LIBR;
function sReadTotal;external LIBR;
function sReadSelTotal;external LIBR;
function RSSequence;external LIBR;
function sDisplayFP600;external LIBR;
function SetDebugMode;external LIBR;
function ClearDebugMode;external LIBR;
function pWriteLogo;external LIBR;
function pWriteFooterLines;external LIBR;
function pReadFooterLines;external LIBR;
function  NonFiscalPrintoutBegin;external LIBR;
function  pNonFiscalPrintoutLine;external LIBR;
function  NonFiscalPrintoutEnd;external LIBR;
function OptimizeTransmission;external LIBR;
function CancellationReason;external LIBR;
end.
